



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>PHP的命名空间 与类是自动加载</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">PHP的命名空间 与类是自动加载</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 11:00:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>namespace</h1>
<p>假设如果不使用namespace，那么每个类在一个项目中的名字就必须是固定的。因为php在new的时候不管是调用autoload还是调用已加载过的类，都存在一个类名对应的文件。所以在没有namespace的时候，我们会想各种命名规则来区分不同的类，比如project1_school1_class1_Student或者project2_school_class_Student。</p>
<p>引入namespace之后就可以将这个有效规避了，一个namespace就相当于对应一个文件路径，查找这个类的时候，就会去对应的文件路径查找类定义文件了。</p>
<p>代码</p>
<p>目录结果</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/540840/201603/540840-20160304144118002-1110030356.png" /></p>
<p>A_def.php</p>
<div>
<pre class="prettyprint linenums">namespace my_api\named;

class A {

    public function def1() {<br />
        echo 11;<br />
    }

    public static function  static_def(){<br />
        echo 'static';<br />
    }

}</pre>
</div>
<p>test.php</p>
<div>
<pre class="prettyprint linenums">require_once("api/A_def.php");<br />
$a = new my_api\named\A();<br />
$a-&gt;def1();

$b= my_api\named\A::static_def();<br />
print_r($b);</pre>
</div>
<p>namespace 后的命名空间起始不能用&ldquo;\&rdquo;,</p>
<p><strong>Fatal error</strong>: Undefined constant 'my_namespace' in&hellip;&hellip;&hellip;&hellip;&hellip;&hellip;&hellip;&hellip;</p>
<p>-----------------------------------------------------------------</p>
<h1>spl_autoload_register</h1>
<div>
<pre class="prettyprint linenums">bool spl_autoload_register ([ callable $autoload_function [, bool $throw = true [, bool $prepend = false ]]] )</pre>
</div>
<p>将函数注册到SPL __autoload函数队列中。如果该队列中的函数尚未激活，则激活它们。</p>
<p>如果在你的程序中已经实现了<a href="http://cn2.php.net/manual/zh/function.autoload.php" rel="external nofollow noreferrer">__autoload()</a>函数，它必须显式注册到<a href="http://cn2.php.net/manual/zh/function.autoload.php" rel="external nofollow noreferrer">__autoload()</a>队列中。因为&nbsp;spl_autoload_register()函数会将Zend Engine中的<a href="http://cn2.php.net/manual/zh/function.autoload.php" rel="external nofollow noreferrer">__autoload()</a>函数取代为<a href="http://cn2.php.net/manual/zh/function.spl-autoload.php" rel="external nofollow noreferrer">spl_autoload()</a>或<a href="http://cn2.php.net/manual/zh/function.spl-autoload-call.php" rel="external nofollow noreferrer">spl_autoload_call()</a>。</p>
<p>如果需要多条 autoload 函数，spl_autoload_register()&nbsp;满足了此类需求。 它实际上创建了 autoload 函数的队列，按定义时的顺序逐个执行。相比之下，&nbsp;<a href="http://cn2.php.net/manual/zh/function.autoload.php" rel="external nofollow noreferrer">__autoload()</a>&nbsp;只可以定义一次。</p>
<p>*注 &nbsp;__autoload 将会废弃</p>
<div>
<pre class="prettyprint linenums">// function __autoload($class) {<br />
//     include 'classes/' . $class . '.class.php';<br />
// }

function my_autoloader($class) {<br />
    include 'classes/' . $class . '.class.php';<br />
}

spl_autoload_register('my_autoloader');

// 或者，自 PHP 5.3.0 起可以使用一个匿名函数<br />
spl_autoload_register(function ($class) {<br />
    include 'classes/' . $class . '.class.php';<br />
});</pre>
</div>
<p>Yii2 注册类使用spl_autoload_register 所以文件名和命名空间的路径必须一直</p>
<p>目录结构</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/540840/201603/540840-20160304145552471-651772167.png" /></p>
<p>B.php</p>
<div>
<pre class="prettyprint linenums">namespace my_namespace;

class B {

    public static function  static_def(){<br />
        echo 'static';<br />
    }

}</pre>
</div>
<p>test.php</p>
<div>
<pre class="prettyprint linenums">/**<br />
 * spl_autoload_register<br />
 */<br />
function my_autoloader($class) {<br />
    $class= str_replace('my_namespace', '', $class);<br />
    include 'api/' . $class . '.php';<br />
}<br />
spl_autoload_register('my_autoloader');

$c= my_namespace\B::static_def();</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxn2nz8.html">Windows环境搭建Red5流媒体服务器指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4nrk59.html">hibernate中validate的使用（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kkno58.html">ExtJS入门实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96konvq.html">Hibernate uniqueResult方法的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oj7139.html">zw版【转发&amp;&num;183&semi;台湾nvp系列Delphi例程】HALCON SetMshape</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okkvvl9.html">poj1584A Round Peg in a Ground Hole</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydoxxxq.html">初尝Windows 下批处理编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wvxpwq.html">坑爹的libxml2 for mingw 编译 （二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96okpkn9.html">angularjs &plus; springmvc 上传和下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdwno79.html">深入了解setInterval方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me2jv2q.html">Php设计模式&lpar;三&rpar;：行为型模式part1</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pyl5n8.html">sublime Text3  新建文件时定义模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv177e1q.html">个人的MySql配置总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvv62g8.html">&lbrack;Java Plasterer&rsqb; Java Components 3：Java Enum</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7onn4x8.html">OCM 学习练习题目</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zynvlv9.html">爬取笔下wenxue小说</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvyv42q.html">OpenHaptics编程环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2xz608.html">Apache之&period;htaccess备忘录&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppyd3k9.html">&lbrack;Node&period;js&rsqb;28&period; Level 5&colon; Express Server</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p5lxg8.html">java设计模式4--建造者模式（Builder）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/wq1ved4q.html">教你一招：解决windows xp系统开机出现&OpenCurlyDoubleQuote;disk checking has been canceled&rdquo;</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwl7dr9.html">Web Analytics 2&period;0 中文翻译 &lbrack; 系列索引 &rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9je17g8.html">【转】ASP&period;NET MVC学习笔记-Controller的ActionResult</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pmkp49.html">PAT mooc DataStructure 4-2 SetCollection</a>
			</li>
						<li><a href="https://www.batexi.com/a/49g34y7q.html">PHP开发程序应该注意的42个优化准则</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q77n7gq.html">PHP 5&period;4 已废弃 magic&lowbar;quotes&lowbar;gpc，PHP安全转义函数详解（addslashes 、htmlspecialchars、htmlentities、mysql&lowbar;real&lowbar;escape&lowbar;string、strip&lowbar;tags）</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd5og09.html">【Alpha】Daily Scrum Meeting第一次</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxle3dq.html">&period;net WebServer例</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qworgy9.html">Java四种线程池的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlokz0q.html">PHP 动态生成验证码</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
